#define NUMOPTIONS 8
#define DEFAULTOPTION (NUMOPTIONS-1)

extern long long cpucycles_ticks_amd64_pmc_setup(void);
extern long long cpucycles_ticks_amd64_pmc(void);
extern long long cpucycles_ticks_amd64_tsc_setup(void);
extern long long cpucycles_ticks_amd64_tsc(void);
extern long long cpucycles_ticks_amd64_tscasm_setup(void);
extern long long cpucycles_ticks_amd64_tscasm(void);
extern long long cpucycles_ticks_default_perfevent_setup(void);
extern long long cpucycles_ticks_default_perfevent(void);
extern long long cpucycles_ticks_default_mach_setup(void);
extern long long cpucycles_ticks_default_mach(void);
extern long long cpucycles_ticks_default_monotonic_setup(void);
extern long long cpucycles_ticks_default_monotonic(void);
extern long long cpucycles_ticks_default_gettimeofday_setup(void);
extern long long cpucycles_ticks_default_gettimeofday(void);
extern long long cpucycles_ticks_default_zero_setup(void);
extern long long cpucycles_ticks_default_zero(void);

static struct {
  const char *implementation;
  long long (*ticks_setup)(void);
  long long (*ticks)(void);
} options[NUMOPTIONS] = {
{ "amd64-pmc", cpucycles_ticks_amd64_pmc_setup, cpucycles_ticks_amd64_pmc },
{ "amd64-tsc", cpucycles_ticks_amd64_tsc_setup, cpucycles_ticks_amd64_tsc },
{ "amd64-tscasm", cpucycles_ticks_amd64_tscasm_setup, cpucycles_ticks_amd64_tscasm },
{ "default-perfevent", cpucycles_ticks_default_perfevent_setup, cpucycles_ticks_default_perfevent },
{ "default-mach", cpucycles_ticks_default_mach_setup, cpucycles_ticks_default_mach },
{ "default-monotonic", cpucycles_ticks_default_monotonic_setup, cpucycles_ticks_default_monotonic },
{ "default-gettimeofday", cpucycles_ticks_default_gettimeofday_setup, cpucycles_ticks_default_gettimeofday },
{ "default-zero", cpucycles_ticks_default_zero_setup, cpucycles_ticks_default_zero },
} ;
